/*
 *                        sldumpdialog.h
 *                           -------------------
 *  begin                : gio ago 28 2003
 *  copyright            : (C) 2003 by giuseppe massimo bertani
 *  email                : gmbertani@serlook.sunsite.dk
 *
 *
 *
 *                                                                         
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.                                   
 *                                                                         
 *  Coding style params: 
 *  <TAB> skips=4
 *  <TAB> are replaced with blanks
 *  
 *   Best viewed with Vim 6.x and included vimrc file ;-)
 *   
 * $Id: sldumpdialog.h,v 1.4 2005/01/21 08:40:57 gbertani Exp $
 */

#ifndef SLDUMPDIALOG_H
#define SLDUMPDIALOG_H

#include "slviewdialogbase.h"

/**Dump views parameters dialog
  *@author giuseppe massimo bertani
  */

class SLDumpDialog : public SLViewDialogBase  
{
   Q_OBJECT

public: 
       
    enum Page 
    {
        pageSourceBuffer,     
        pageDataFormat
        //colors, fonts, etc. to be added
    };
    
    enum DataFormat
    {
        Hexadecimal = 0,
        Decimal,
        Octal,
        Binary,
        Ascii
    };

    
	SLDumpDialog(QWidget *parent=0, const char *name=0);
	~SLDumpDialog();

    void save(KConfig* data);
    void load(KConfig const* data);
    
//--------------- gets -----------------------------------------------------

    /** returns the id of the item selected in the dialog */
    DataFormat getDataFormat() const;
    bool getOffsetFormat() const;
   
    
//----------sets-------------------------------------------------------------   
    
    /** sets the given item as selected in the dialog */
    void setDataFormat( DataFormat f );

    void setOffsetFormat( bool f );

//---------------------------------------------------

public slots:
    virtual void slotAllDefaults();
    virtual void slotDefault();
    virtual void slotApply();

signals:
    void dataFormatChoice();

private:

    struct SDataFormat
    {
        QComboBox   *dataFormatSelector;
        QLabel      *dataFormatLabel;
        QCheckBox   *offsetFormatBox;
        QLabel      *offsetFormatLabel;        
    };

    SDataFormat     mDataFormat; 
    
    void setupDataFormatPage();
    virtual void setupSourceBufferPage();
};


#endif
