/*
 *                        sleventdialog.h  -  description
 *                           -------------------
 *  begin                : lun feb 9 2004
 *  copyright            : (C) 2004 by giuseppe massimo bertani
 *  email                : gmbertani@serlook.sunsite.dk
 *
 *
 *
 *                                                                         
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.                                   
 *                                                                         
 *  Coding style params: 
 *  <TAB> skips=4
 *  <TAB> are replaced with blanks
 *  
 *   Best viewed with Vim 6.x and included vimrc file ;-)
 *   
 * $Id: sleventdialog.h,v 1.1 2004/02/25 16:10:20 gbertani Exp $
 */

#ifndef SLEVENTDIALOG_H
#define SLEVENTDIALOG_H

#include "slviewdialogbase.h"

/**Event views parameters dialog
  *@author giuseppe massimo bertani
  */

class SLEventDialog : public SLViewDialogBase  
{
    Q_OBJECT

public: 
       
    enum Page 
    {
        pageSourceBuffer,
        pageSettingsParams
        //colors, fonts, etc. to be added
    };
    
	SLEventDialog(QWidget *parent=0, const char *name=0);
	~SLEventDialog();

    void save(KConfig* data);
    void load(KConfig const* data);
    
//--------------- gets -----------------------------------------------------

    /** returns the id of the item selected in the dialog */
    bool getSkip() const;
   
     
//----------sets-------------------------------------------------------------   

     /** sets the given item as selected in the dialog */
    void setSkip( bool skip );

//---------------------------------------------------

public slots:
    virtual void slotAllDefaults();
    virtual void slotDefault();
    virtual void slotApply();
    
signals:
    void settingsChoice();

private:

    struct SSettingsParams
    {

        QCheckBox   *skipBox;
        QLabel      *skipLabel;
    };

    SSettingsParams mSettingsParams; 
    
    void setupSettingsParamsPage();
    virtual void setupSourceBufferPage();
};

#endif
