/*
 *                        sllogbrowser.h  -  description
 *                           -------------------
 *  begin                : gio feb 12 2004
 *  copyright            : (C) 2004 by giuseppe massimo bertani
 *  email                : gmbertani@serlook.sunsite.dk
 *
 *
 *
 *                                                                         
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.                                   
 *                                                                         
 *  Coding style params: 
 *  <TAB> skips=4
 *  <TAB> are replaced with blanks
 *  
 *   Best viewed with Vim 6.x and included vimrc file ;-)
 *   
 * $Id: sllogbrowser.h,v 1.5 2005/01/21 08:40:58 gbertani Exp $
 */

#ifndef SLLOGBROWSER_H
#define SLLOGBROWSER_H

#include <assert.h>
#include <qtextedit.h>
#include <kglobalsettings.h>

/**
 * Extends KTextEdit to support rightclick
 * and event row selection
 * 
  *@author giuseppe massimo bertani
  */

class QPopupMenu;

class SLLogBrowser : public QTextEdit  
{
    Q_OBJECT

public:
    /**
     *
     */
	SLLogBrowser( QWidget *parent, const char *name );

    /**
     *
     */      
    ~SLLogBrowser();
    /**
     *
     */
    void showEvent( uint event );

    /**
     *
     */
    uint getShowedEvents() const;
    
    /**
     *
     */
    int getLineHeight() const;

    /**
     *
     */
    int getLineWidth( const QString& s ) const;

    /**
     *
     */
    void setHeadingSize( uint hs )
    {
        headingSize = hs;
    }                                                 

signals:
    /** */
    void mouseRightClick();

    /**  */
    void scrollBarChanged(uint para);



public slots:
    /** */
    virtual void append ( const QString& text );
    
protected slots:

    /** */
    void slotValueChanged(int value);

    
            
protected:
    
    /** reimplemented from QTextEdit to manage
     * the mouse right click 
     */ 
    virtual QPopupMenu* createPopupMenu ( const QPoint & pos );

    /**
     * amount of lines used for log heading
     */
    uint headingSize;

    /**
     * last paragraph showed (selected)
     */
    uint currPara;

    /**
     * total paragraphs
     */
    uint totPara;

    /**
     * pixel height of all the client area
     */
    uint yHeight;

    /**
     */
     bool ignoreSignals;
     
};

#endif
