/*
 *                        slmodemleds.cpp  -  description
 *                           -------------------
 *  begin                : Fri Dec 19 2003
 *  copyright            : (C) 2003 by giuseppe massimo bertani
 *  email                : gmbertani@serlook.sunsite.dk
 *
 *
 *
 *                                                                         
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.                                   
 *                                                                         
 *  Coding style params: 
 *  <TAB> skips=4
 *  <TAB> are replaced with blanks
 *  
 *   Best viewed with Vim 6.x and included vimrc file ;-)
 *   
 * 
 */
static char* cvs_id = "$Id";


#include "slmodemleds.h"

SLModemLeds::SLModemLeds(bool rxOnly, QWidget *parent, const char *name) :
    ModemStatusLeds( parent, name )
{
    rxOnlyLeds = rxOnly;
    
    layout = new QHBoxLayout( this );
    CHECK_PTR( layout );

    if ( rxOnlyLeds == true )
    {
        KLed_txd->hide();
        KLed_rts->hide();
        KLed_dtr->hide();
    }
    else
    {
        
        layout->addWidget( KLed_txd );
        layout->addWidget( KLed_rts );
        layout->addWidget( KLed_dtr );

    }


    layout->addWidget( KLed_rxd );
    layout->addWidget( KLed_cts );
    layout->addWidget( KLed_dsr );
    layout->addWidget( KLed_dcd );
    layout->addWidget( KLed_ri );

    //QToolTip::add(  this, this->name( "SLModemLeds" ) );

}



void SLModemLeds::slotSetStatus(uint status)
{
    
    //output bits
    KLed_txd->off();
    KLed_rts->off();
    KLed_dtr->off();
    
    //input bits
    KLed_rxd->off();
    KLed_cts->off();
    KLed_dsr->off();
    KLed_dcd->off();
    KLed_ri->off();

    if((status & TIOCM_ST) != 0)
    {
        KLed_txd->on();
    }

    if((status & TIOCM_RTS) != 0)
    {
        KLed_rts->on();
    }

    if((status & TIOCM_DTR) != 0)
    {
        KLed_dtr->on();
    }

    if ((status & TIOCM_DSR) != 0)
    {
        KLed_dsr->on();
    }

    if((status & TIOCM_SR) != 0)
    {
        KLed_rxd->on();
    }

    if((status & TIOCM_CTS) != 0)
    {
        KLed_cts->on();
    }

    if((status & TIOCM_CD) != 0)
    {
        KLed_dcd->on();
    }

    if((status & TIOCM_RNG) != 0)
    {
        KLed_ri->on();
    }

}


QSize SLModemLeds::sizeHint() const
{
    if ( rxOnlyLeds == true )
    {
        return QSize(40,12);
    }
    else
    {
        return QSize(64,12);
    }
}

