/*
 *                        slviewdialogbase.cpp
 *                           -------------------
 *  begin                : lun set 1 2003
 *  copyright            : (C) 2003 by giuseppe massimo bertani
 *  email                : gmbertani@serlook.sunsite.dk
 *
 *
 *
 *                                                                         
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.                                   
 *                                                                         
 *  Coding style params: 
 *  <TAB> skips=4
 *  <TAB> are replaced with blanks
 *  
 *   Best viewed with Vim 6.x and included vimrc file ;-)
 *   
 * 
 */
static char* cvs_id = "$Id";


#include "slviewdialogbase.h"

const int SLViewDialogBase::pageSourceBuffer = 0; //page index for source buffer tab.


SLViewDialogBase::SLViewDialogBase(QString title, QWidget *parent, const char *name, bool modal ) 
    : KDialogBase( Tabbed, title, Help|Default|Apply|Ok|Cancel, Ok, parent, name, modal, true )
{
    setHelp( "serlook/index.html", QString::null ); // When Help is pressed
}

SLViewDialogBase::~SLViewDialogBase()
{
}


void SLViewDialogBase::slotOk()
{
    slotApply();
    accept();
}

void SLViewDialogBase::slotApply()
{
    int idx = activePageIndex();
    qDebug( "%s:%u - view dialog selected page index: %d", __FILE__, __LINE__, idx );

    if( idx == pageSourceBuffer)
    {
        emit sourceBufferChoice();
    }
    
}

BufferLine SLViewDialogBase::getSourceBuffer() const
{
    return (BufferLine) mSourceBuffer.sourceBufferSelector->currentItem();
}


bool SLViewDialogBase::getSyncView() const
{
    return mSourceBuffer.syncViewBox->isChecked();
}

void SLViewDialogBase::setSourceBuffer( BufferLine b )
{
    mSourceBuffer.sourceBufferSelector->setCurrentItem( b );
   
}

void SLViewDialogBase::setSyncView( bool sync )
{
    mSourceBuffer.syncViewBox->setChecked( sync );
}


void SLViewDialogBase::save(KConfig* data)
{
    data->writeEntry("Connected Line", getSourceBuffer());
    data->writeEntry("Accepts Sync", getSyncView());
}

void SLViewDialogBase::load(KConfig const* data)
{
    setSourceBuffer( (BufferLine) data->readUnsignedNumEntry("Connected Line") );
    setSyncView( data->readBoolEntry("Accepts Sync") );
    emit sourceBufferChoice();
}





